LoRom

;Speed = XYZZ
;		X - Speed of X movement (can be negative)
;		Y - Speed of Y movement (can be negative)
;		ZZ - Delay when spike hits a wall before moving away again (pixels)
;Speed2 = XXYY
;		XX - Distance spike can be moved by shooting (pixels)
;		YY - Pause timer when shot (frames)

org $A0F7D3
	DW $0080,#Palette,$7FFF,$0030,$0007,$0007
	DB $A3,$00,$00,$00,$00,$00
	DW #Initiation,$0001,$0000,#Running,$800F,$804C,$8041,$0000,$0000
	DW $0000,$0000,$0000,$0000,$0000,$0000,$8023,#ShotReact,$0000
	DL $AFEC00
	DB $02
	DW $F320,$F026,$DDEB
org $A3F311
Palette:
	DW $0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
	DW $0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
Tilemap:
	DW $0010,Spikey
	DW $80ED,Tilemap
Spikey:
	DW $0004
	DB $F8,$01,$F8,$00,$21
	DB $00,$00,$F8,$01,$21
	DB $F8,$01,$00,$02,$21
	DB $00,$00,$00,$03,$21
Initiation:
	LDX $0E54
	LDA #Tilemap : STA $0F92,X
	STZ $0FAC,X : STZ $0FAE,X : STZ $0FB0,X
	LDA $0FB4,X : AND #$F000 : LSR A : LSR A : LSR A : LSR A : XBA : JSR NegativeSpeedCheck : STA $0FA8,X
	LDA $0FB4,X : AND #$0F00 : XBA : JSR NegativeSpeedCheck : STA $0FAA,X
	RTL
NegativeSpeedCheck:
		CMP #$0008 : BCC $03 : ORA #$FFF0 : RTS
Running:
	JSR ShotMoveCheck
	LDX $0E54
	LDA $0FAC,X : BEQ MoveSpikes : DEC $0FAC,X
	RTL
MoveSpikes:
	JSR HSpikes : STA $0FA8,X
	JSR VSpikes : STA $0FAA,X
	RTL
HSpikes:
		LDA $0FA8,X : PHA
		STA $14 : STZ $12 : JSL $A0C6AB
		BCS HitWall
		PLA : RTS
VSpikes:
		LDA $0FAA,X : PHA
		STA $14 : STZ $12 : JSL $A0C786
		BCS HitWall
		PLA : RTS
HitWall:
		LDA #$002F : JSL $8090C1
		LDA $0FB4,X : AND #$00FF : STA $0FAC,X
		PLA : EOR #$FFFF : INC A : RTS
ShotMoveCheck:
		LDX $0E54
		LDA $0FAE,X : BEQ EndMoveCheck : DEC A : STA $0FAE,X
		LDA $0FB0,X : AND #$000F : ASL A : TAX
		STZ $12 : JSR (ShotMoveTable,X)
EndMoveCheck:
		RTS
ShotMoveTable:
		DW ShotMoveUpR,ShotMoveUpRight, ShotMoveRight, ShotMoveDownRight, ShotMoveDownR
		DW ShotMoveDownL, ShotMoveDownLeft, ShotMoveLeft, ShotMoveUpLeft, ShotMoveUpL
	ShotMoveUpR:
	ShotMoveUpL:
		LDX $0E54 : LDA #$FFFF : STA $14 : JSL $A0C786 : RTS
	ShotMoveUpRight:
		LDX $0E54 : LDA #$FFFF : STA $14 : JSL $A0C786 : LDA #$0001 : STA $14 : JSL $A0C6AB : RTS
	ShotMoveRight:
		LDX $0E54 : LDA #$0001 : STA $14 : JSL $A0C6AB : RTS
	ShotMoveDownRight:
		LDX $0E54 : LDA #$0001 : STA $14 : JSL $A0C786 : LDA #$0001 : STA $14 : JSL $A0C6AB : RTS
	ShotMoveDownR:
	ShotMoveDownL:
		LDX $0E54 : LDA #$0001 : STA $14 : JSL $A0C786 : RTS
	ShotMoveDownLeft:
		LDX $0E54 : LDA #$0001 : STA $14 : JSL $A0C786 : LDA #$FFFF : STA $14 : JSL $A0C6AB : RTS
	ShotMoveLeft:
		LDX $0E54 : LDA #$FFFF : STA $14 : JSL $A0C6AB : RTS
	ShotMoveUpLeft:
		LDX $0E54 : LDA #$FFFF : STA $14 : JSL $A0C786 : LDA #$FFFF : STA $14 : JSL $A0C6AB : RTS
ShotReact:
	PHY : LDX $0E54
	LDA $0FB6,X : AND #$00FF : BEQ $07 : CLC : ADC $0FAC,X : STA $0FAC,X
	LDA $0FB6,X : AND #$FF00 : BEQ $04 : XBA : STA $0FAE,X
	LDA $18A6 : ASL A : TAY : LDA $0C04,Y : AND #$000F : STA $0FB0,X
	PLY : JMP $802D